/*
          Copyright (C) 1993, 1994, RSNA and Washington University

          The software and supporting documentation for the Radiological
          Society of North America (RSNA) 1993, 1994 Digital Imaging and
          Communications in Medicine (DICOM) Demonstration were developed
          at the
                  Electronic Radiology Laboratory
                  Mallinckrodt Institute of Radiology
                  Washington University School of Medicine
                  510 S. Kingshighway Blvd.
                  St. Louis, MO 63110
          as part of the 1993, 1994 DICOM Central Test Node project for, and
          under contract with, the Radiological Society of North America.

          THIS SOFTWARE IS MADE AVAILABLE, AS IS, AND NEITHER RSNA NOR
          WASHINGTON UNIVERSITY MAKE ANY WARRANTY ABOUT THE SOFTWARE, ITS
          PERFORMANCE, ITS MERCHANTABILITY OR FITNESS FOR ANY PARTICULAR
          USE, FREEDOM FROM ANY COMPUTER DISEASES OR ITS CONFORMITY TO ANY
          SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND PERFORMANCE OF
          THE SOFTWARE IS WITH THE USER.

          Copyright of the software and supporting documentation is
          jointly owned by RSNA and Washington University, and free access
          is hereby granted as a license to use this software, copy this
          software and prepare derivative works based upon this software.
          However, any distribution of this software source code or
          supporting documentation or derivative works (source code and
          supporting documentation) must include the three paragraphs of
          the copyright notice.
*/
/* Copyright marker.  Copyright will be inserted above.  Do not remove */
/*
+-+-+-+-+-+-+-+-+-
*/



#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include "lst.h"
#include "dicom_objects.h"



#define FF  '/f'
#define LF  '/n'
#define CR  '/r'



CONDITION iodvprv_defaultRepertoire(char s);
CONDITION UID_MATCH(DCM_OBJECT ** object);
CONDITION iodvprv_controlCharacter(char s);
CONDITION iodvprv_aeTest(long length, char *input, int group, int element);
CONDITION iodvprv_asTest(long length, char *input, int group, int element);
CONDITION iodvprv_atTest(long length, char vmnum[4], int group, int element);
CONDITION iodvprv_csTest(long length, char *input, int group, int element);
CONDITION iodvprv_daTest(long length, char *input, int group, int element);
CONDITION iodvprv_ddTest(char *input);
CONDITION iodvprv_dsTest(long length, char *input, int group, int element);
CONDITION iodvprv_dtTest(long length, char *input, int group, int element);
CONDITION iodvprv_flTest(long length, char vmnum[4], int group, int element);
CONDITION iodvprv_fdTest(long length, char vmnum[4], int group, int element);
CONDITION iodvprv_isTest(long length, char *input, int group, int element);
CONDITION iodvprv_loTest(long length, char *input, int group, int element);
CONDITION iodvprv_ltTest(long length, char *input, int group, int element);
CONDITION iodvprv_obTest(char *s);
CONDITION iodvprv_owTest(char *s);
CONDITION iodvprv_pnTest(long length, char *input, int group, int element);
CONDITION iodvprv_shTest(long length, char *input, int group, int element);
CONDITION iodvprv_slTest(long length, char vmnum[4], int group, int element);
CONDITION iodvprv_sqTest(char *s);
CONDITION iodvprv_ssTest(long length, char vmnum[4], int group, int element);
CONDITION iodvprv_stTest(long length, char *input, int group, int element);
CONDITION iodvprv_tmTest(long length, char *input, int group, int element);
CONDITION iodvprv_uiTest(long length, char *input, int group, int element);
CONDITION iodvprv_ulTest(long length, char vmnum[4], int group, int element);
CONDITION iodvprv_usTest(long length, char vmnum[4], int group, int element);
char *IODV_Message(CONDITION cond);


#define IODV_INVALID FORM_COND(FAC_IODV, SEV_SUCC,0)
#define IODV_VALID FORM_COND(FAC_IODV, SEV_SUCC, 1)
#define IODV_MALLOCERROR FORM_COND(FAC_IODV, SEV_ERROR, 2)
#define IODV_DATAFILECORRUPT FORM_COND(FAC_IODV, SEV_ERROR,3)
#define IODV_DCMLOOKUPFAILED FORM_COND(FAC_IODV, SEV_ERROR,4)
#define IODV_INVALIDSOP FORM_COND(FAC_IODV, SEV_ERROR, 5)
#define IODV_ZEROLENGTH FORM_COND(FAC_IODV, SEV_ERROR, 6)
#define IODV_ATTRIBUTEMISSING FORM_COND(FAC_IODV, SEV_ERROR,7)
#define IODV_ERROR FORM_COND(FAC_IODV,SEV_ERROR,8)
#define IODV_NORMAL FORM_COND(FAC_IODV,SEV_SUCC,9)
#define IODV_CONDITION FORM_COND(FAC_IODV,SEV_SUCC,10)
#define IODV_FILEOPENERROR FORM_COND(FAC_IODV,SEV_ERROR,11)
#define IODV_DATALENGTHERROR FORM_COND(FAC_IODV,SEV_ERROR,12)
#define IODV_DATAINCORRECT FORM_COND(FAC_IODV,SEV_ERROR,13)
#define IODV_INCORRECTVM FORM_COND(FAC_IODV,SEV_ERROR,14)
#define IODV_CONDITIONNOTMET FORM_COND(FAC_IODV, SEV_ERROR, 15)
#define IODV_RESTRICTIONNOTMET FORM_COND(FAC_IODV, SEV_ERROR, 16)
#define IODV_PARSEFILEUNDEFINED FORM_COND(FAC_IODV, SEV_ERROR, 17)
#define IODV_PARSEFILEERROR FORM_COND(FAC_IODV, SEV_ERROR, 18)
#define IODV_ATTRIBUTEZEROLENGTH FORM_COND(FAC_IODV, SEV_ERROR, 19)
